"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantInterpretationLog(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "caseId",
        "familyId",
        "timestamp",
        "user",
        "variantClassification",
        "variantCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import reports as reports_6_0_0

        return {
            "VariantValidation": reports_6_0_0.VariantValidation,
            "user": reports_6_0_0.User,
            "variantClassification": reports_6_0_0.GuidelineBasedVariantClassification,
            "variantCoordinates": reports_6_0_0.VariantCoordinates,
            "variantValidation": reports_6_0_0.VariantValidation,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import reports as reports_6_0_0

        return {
            "org.gel.models.report.avro.VariantValidation": reports_6_0_0.VariantValidation,
            "org.gel.models.report.avro.User": reports_6_0_0.User,
            "org.gel.models.report.avro.GuidelineBasedVariantClassification": reports_6_0_0.GuidelineBasedVariantClassification,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_0_0.VariantCoordinates,
            "org.gel.models.report.avro.VariantValidation": reports_6_0_0.VariantValidation,
            "org.gel.models.report.avro.VariantInterpretationLog": reports_6_0_0.VariantInterpretationLog,
        }

    __slots__ = [
        "caseId",
        "familyId",
        "timestamp",
        "user",
        "variantClassification",
        "variantCoordinates",
        "Artifact",
        "VariantValidation",
        "comments",
        "decisionSupportSystemFilters",
        "variantValidation",
    ]

    def __init__(
        self,
        caseId,
        familyId,
        timestamp,
        user,
        variantClassification,
        variantCoordinates,
        Artifact=None,
        VariantValidation=None,
        comments=None,
        decisionSupportSystemFilters=None,
        variantValidation=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_0_0.VariantInterpretationLog model.

        :param caseId:
        :type caseId: str
        :param familyId:
        :type familyId: str
        :param timestamp:
        :type timestamp: str
        :param user:
        :type user: User
        :param variantClassification:
        :type variantClassification: GuidelineBasedVariantClassification
        :param variantCoordinates:
        :type variantCoordinates: VariantCoordinates
        :param Artifact:
        :type Artifact: None | boolean
        :param VariantValidation:
        :type VariantValidation: None | VariantValidation
        :param comments:
        :type comments: None | list[str]
        :param decisionSupportSystemFilters:
        :type decisionSupportSystemFilters: None | dict[str, str]
        :param variantValidation:
        :type variantValidation: None | VariantValidation
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.0.0"
